"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var _objectWithoutProperties = require("@babel/runtime/helpers/objectWithoutProperties"), _extends = require("@babel/runtime/helpers/extends"), react = require("react"), core = require("@keystone-ui/core"), popover = require("@keystone-ui/popover");

function _interopDefault(e) {
  return e && e.__esModule ? e : {
    default: e
  };
}

var _objectWithoutProperties__default = _interopDefault(_objectWithoutProperties), _extends__default = _interopDefault(_extends);

function _defineProperty(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value: value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

const Tooltip = ({children: children, content: content, placement: placement = "top"}) => {
  const {isOpen: isOpen, setOpen: setOpen, trigger: trigger, dialog: dialog, arrow: arrow} = popover.usePopover({
    placement: placement,
    modifiers: [ {
      name: "offset",
      options: {
        offset: [ 0, 12 ]
      }
    } ]
  }), tooltipId = core.useId(), showTooltip = () => setOpen(!0), hideTooltip = () => setOpen(!1);
  return core.jsx(react.Fragment, null, children({
    onMouseEnter: showTooltip,
    onMouseLeave: hideTooltip,
    onFocus: showTooltip,
    onBlur: hideTooltip,
    "aria-describedby": tooltipId,
    ref: trigger.ref
  }), core.jsx(TooltipElement, _extends__default.default({
    id: tooltipId,
    isVisible: isOpen,
    ref: dialog.ref
  }, dialog.props, {
    arrow: arrow
  }), content));
}, TooltipElement = react.forwardRef(((_ref, consumerRef) => {
  let {isVisible: isVisible, children: children, arrow: arrow} = _ref, props = _objectWithoutProperties__default.default(_ref, [ "isVisible", "children", "arrow" ]);
  const {elevation: elevation, radii: radii, colors: colors, spacing: spacing, typography: typography} = core.useTheme(), arrowStyles = useArrowStyles();
  return core.jsx(core.Portal, null, core.jsx("div", _extends__default.default({
    role: "tooltip",
    "aria-hidden": !isVisible,
    ref: consumerRef,
    css: _objectSpread2({
      backgroundColor: colors.foregroundMuted,
      borderRadius: radii.xsmall,
      color: colors.background,
      fontSize: typography.fontSize.small,
      fontWeight: typography.fontWeight.medium,
      lineHeight: typography.leading.tight,
      maxWidth: 320,
      opacity: isVisible ? 1 : 0,
      padding: `${spacing.small}px ${spacing.medium}px`,
      pointerEvents: isVisible ? void 0 : "none",
      zIndex: elevation.e500
    }, arrowStyles)
  }, props), children, core.jsx("div", _extends__default.default({
    "data-popper-arrow": !0,
    ref: arrow.ref,
    className: "tooltipArrow"
  }, arrow.props))));
})), useArrowStyles = () => {
  const {colors: colors} = core.useTheme();
  return {
    ".tooltipArrow": {
      position: "absolute",
      overflow: "hidden",
      pointerEvents: "none",
      height: "20px",
      width: "20px",
      "&::after": {
        content: "close-quote",
        position: "absolute",
        width: "10px",
        height: "10px",
        backgroundColor: colors.foregroundMuted,
        transform: "translateX(-50%) translateY(-50%) rotate(45deg)"
      }
    },
    "&[data-popper-placement^='left'] > .tooltipArrow": {
      left: "100%",
      "&::after": {
        top: "50%",
        left: "0"
      }
    },
    "&[data-popper-placement^='right'] > .tooltipArrow": {
      right: "100%",
      "&::after": {
        top: "50%",
        left: "100%"
      }
    },
    "&[data-popper-placement^='top'] > .tooltipArrow": {
      top: "100%",
      "&::after": {
        top: 0,
        bottom: "-50%",
        left: "50%"
      }
    },
    "&[data-popper-placement^='bottom'] > .tooltipArrow": {
      bottom: "100%",
      right: "unset",
      "&::after": {
        bottom: "-50%",
        left: "50%"
      }
    }
  };
};

exports.Tooltip = Tooltip;
